/*
 * Copyright (c) 2007, Ryo Ichinose
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 *
 *    * Redistributions of source code must retain the above copyright 
 *      notice, this list of conditions and the following disclaimer.
 *    * Redistributions in binary form must reproduce the above copyright 
 *      notice, this list of conditions and the following disclaimer in the 
 *      documentation and/or other materials provided with the distribution.
 *    * Neither the name of the auther nor the 
 *      names of its contributors may be used to endorse or promote products 
 *      derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, 
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <avr/interrupt.h>
#include <avr/io.h>
#include <inttypes.h>

#include "timer1.h"


static void (*timer1_ov_interrupt_handler)(void);
static void (*timer1_compa_interrupt_handler)(void);
static void (*timer1_compb_interrupt_handler)(void);
static void (*timer1_ic_interrupt_handler)(void);


/*
 * Сեߥϥɥ
 */
ISR(TIMER1_OVF_vect)
{
	timer1_ov_interrupt_handler();
}


/*
 * Сե˳ߥϥɥǼ¹Ԥ
 * 桼ؿꤹ롣
 */
void 
timer1_ov_set_interrupt(void (*func)(void))
{
	timer1_ov_interrupt_handler = func;
}


/*
 * A׳ߥϥɥ
 */
ISR(TIMER1_COMPA_vect)
{
	timer1_compa_interrupt_handler();
}


/*
 * A׻˳ߥϥɥǼ¹Ԥ桼ؿꤹ롣
 */
void
timer1_compa_set_interrupt(void (*func)(void))
{
	timer1_compa_interrupt_handler = func;
}


/*
 * B׳ߥϥɥ
 */
ISR(TIMER1_COMPB_vect)
{
	timer1_compb_interrupt_handler();
}


/*
 * B׻˳ߥϥɥǼ¹Ԥ桼ؿꤹ롣
 */
void
timer1_compb_set_interrupt(void (*func)(void))
{
	timer1_compb_interrupt_handler = func;
}


ISR(TIMER1_CAPT_vect)
{
	timer1_ic_interrupt_handler();
}


/*
 * ͳߥϥɥǼ¹Ԥ桼ؿꤹ롣
 */
void
timer1_ic_set_interrupt(void (*func)(void))
{
	timer1_ic_interrupt_handler = func;
}

/* End of timer1.c */
